"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = require("react");
var useRegistry_1 = require("./useRegistry");
function useActions(actionCreators) {
    var registry = useRegistry_1.useRegistry();
    var names = Object.keys(actionCreators);
    return react_1.useMemo(function () {
        return names.reduce(function (mapped, key) {
            mapped[key] = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var action = actionCreators[key].apply(actionCreators, tslib_1.__spread(args));
                registry.dispatch(action);
                return action;
            };
            return mapped;
        }, {});
    }, names);
}
exports.useActions = useActions;
//# sourceMappingURL=useActions.js.map